#ifndef CONTEXT_CONTEXTAPPUI_H_INCLUDED
#define CONTEXT_CONTEXTAPPUI_H_INCLUDED 1

#include "app_context.h"
#include "timeout.h"
#include "list.h"
#include "reporting.h"
#include <eikappui.h>

class MContextAppUi : public MTimeOut, public MActiveErrorReporter {
protected:
	typedef void (MContextAppUi::*TCallBack)(void);

	IMPORT_C void ConstructL(MApp_context& aContext, const TDesC& aLogFileName, TInt aMaxLogCount=0);
	IMPORT_C void QueueOp(TCallBack Op, int AfterSeconds=0);
	IMPORT_C virtual void expired(CBase*);
	IMPORT_C void ReleaseContextAppUi();
	IMPORT_C virtual ~MContextAppUi();

	CTimeOut	 *iWait;
	class Cfile_logger *iLog;
	// MActiveErrorReporter
	IMPORT_C virtual void ReportError(const TDesC& Source,
		const TDesC& Reason, TInt Code);
	IMPORT_C virtual void SetInHandlableEvent(TBool aHandlable);
	IMPORT_C TErrorHandlerResponse HandleError(TInt aError,
	     const SExtendedError& aExtErr,
	     TDes& aErrorText,
	     TDes& aContextText);
	IMPORT_C void LogFormatted(const TDesC& aMsg);
	IMPORT_C static TInt InitializationSteps();
	IMPORT_C virtual void StepDone();

	TInt iExitValue; //set by error handler to be used in User::Exit as necessary

private:
	IMPORT_C virtual void RunOp(TCallBack op);
	CList<TCallBack> *iWaitingOps;
	TBool			iHandlableError;
	MApp_context*	iAppContext;
public:
	IMPORT_C void hide();
	IMPORT_C void unhide();
};

#endif
