#ifndef CONTEXTMEDIAVIEW_H
#define CONTEXTMEDIAVIEW_H

#include <aknview.h>
#include "cm_storage.h"
#include <cpbkcontactengine.h>
#include "view_ids.h"
#include "phonehelper.h"
#include "contextmediaappcontainer.h"
#include "cm_network.h"
#include "transferdir2.h"

class CContextMediaAppThreadView : public CAknView, public MUploadPrompt, public MContextBase
{
public: 
	IMPORT_C CContextMediaAppThreadView(MContextMediaAppUi& aAppUi,	TUid aViewId, TUid aNextViewId, CPostStorage &aStorage, 
					CPostStorage::TOrder aOrder, CPostStorage::TSortBy aSort,
					TInt64 aNode, TBool is_single_thread_view, TBool is_full_screen, 
					phonehelper &aPhoneHelper, CCMNetwork &aCMNetwork, 
					MUploadPrompt * aVisualPrompt, TBool aStandAlone=EFalse,
					class CAknIconArray * aTagIcons=0, class CHttpTransfer2* aTransferer=0,
					class MAskForNames* aAskForNames=0, TInt aResourceId=0
				   );
	IMPORT_C void ConstructL();
	virtual ~CContextMediaAppThreadView();
public:
	virtual void Prompt(const TDesC& FileName, MUploadCallBack* CallBack);
public:
	IMPORT_C void SetNodeId(TInt64 aNode);
	IMPORT_C TBool IsSingleThreadView();

public:
	IMPORT_C void SetTopIndex(TInt idx);
	IMPORT_C void SetCurrentIndex(TInt idx);

public: 
	virtual TUid Id() const;
	virtual void HandleCommandL(TInt aCommand);
	virtual void HandleClientRectChange();
	virtual void DynInitMenuPaneL(TInt aResourceId, CEikMenuPane* aMenuPane);
	IMPORT_C void SetPreviousView(const TVwsViewId& aPrevViewId); // for standalone mode

private:
	void DoActivateL(const TVwsViewId& aPrevViewId, TUid aCustomMessageId, const TDesC8& aCustomMessage);
	void DoDeactivate();

private:
	TBool IsKnownContact(const TDesC& phone_number);

private: 
	CContextMediaAppGeneralContainer* iContainer;
	TUid iViewId;
	TUid iNextViewId;
	TVwsViewId iPrevViewId;
		
	CPostStorage &iStorage;
	CCMNetwork &iCMNetwork;
	CPostStorage::TOrder iOrder;
	CPostStorage::TSortBy iSort;
	TInt64 iNode;

	TInt iTopIndex;
	TInt iCurrentIndex;

	CPbkContactEngine * iEngine;
	TBool owns_engine;

	TBool is_single_thread_view;
	TBool is_full_screen;

	phonehelper &iPhoneHelper;

	TBool iCameraAppFound;
	TBool iCameraApp2Found;
        TBool iVideoAppFound;
	TBool iVideoApp2Found;
	TBool iAudioAppFound;

	MUploadCallBack*	iCallBack;
	MUploadPrompt * iVisualPrompt;
	MContextMediaAppUi& iAppUi;
	TBool iStandAlone;
	class CSendAppUi * iSendUi;
	class CAknIconArray * iTagIcons;
	class CHttpTransfer2* iTransferer;
	class MAskForNames* iAskForNames;
	TInt iResourceId;
};

#endif


