#ifndef CONTEXTMEDIAAPPVIEW2_H
#define CONTEXTMEDIAAPPVIEW2_H

#include <aknview.h>
#include "transferdir2.h"
#include "transfer2.h"
#include "contextmediaappcontainer.h"

class CContextMediaEditorView : public CAknView, public MContextBase, public MUploadPrompt,
	MCoeForegroundObserver, MTimeOut
{
	struct TCallBackItem {
		TFileName		iFileName;
		MUploadCallBack*	iCallBack;
		TCallBackItem() : iCallBack(0) { }
		TCallBackItem(const TDesC& aFileName, MUploadCallBack* aCallBack) :
			iFileName(aFileName), iCallBack(aCallBack) { }
	};

public: 
	IMPORT_C CContextMediaEditorView(
		TUid aViewId, TVwsViewId* NextViewId, MApp_context& Context, CCMNetwork &aCMNetwork, 
		CPostStorage &aStorage, MBBDataFactory * aFactory, CHttpTransfer2* aTransferer,
		TBool aStandAlone=EFalse, class CAknIconArray * iTagIcons=0,
		class MAskForNames* aAskForNames=0);
        IMPORT_C void ConstructL();
        virtual ~CContextMediaEditorView();

public:
	virtual void Prompt(const TDesC& FileName, MUploadCallBack* CallBack);

public: 
        virtual TUid Id() const;
        virtual void HandleCommandL(TInt aCommand);
        virtual void HandleCommandInnerL(TInt aCommand, TFileName& f, MUploadCallBack* cb);
        virtual void HandleClientRectChange();
	virtual void DynInitMenuPaneL(TInt aResourceId,CEikMenuPane* aMenuPane);

private:
        void DoActivateL(const TVwsViewId& aPrevViewId,TUid aCustomMessageId, const TDesC8& aCustomMessage);
        void DoDeactivate();

	//MCoeForegroundObserver
	void HandleGainingForeground();
	void HandleLosingForeground();
	void expired(CBase* );

public:
	IMPORT_C void SetThreadTarget(TInt64 aCodeId);
	IMPORT_C void ResetThreadTarget();
	virtual void SetPresence(class CBBPresence* aPresence); //takes ownership
	IMPORT_C void SetPreviousView(const TVwsViewId& aPrevViewId); // for standalone mode

private: 
        CContextMediaAppPostContainer* iContainer;
	TUid iViewId;
	TVwsViewId iPrevViewId;
	TInt64 iThreadTarget;
	CCMNetwork &iCMNetwork;
	CPostStorage &iStorage;
	MBBDataFactory * iFactory;
	TBool iMediaBrowsingOn;

	// -------
	TVwsViewId*	iNextViewId;
	MUploadCallBack* iCallBack;
	TFileName	iFileName;
	//---------
	CHttpTransfer2* iTransferer;
	CPostStorage::TOrder iOrder;
	CPostStorage::TSortBy iSort;
	TInt64 iNode;
	TBool		iStandAlone;

	class CSendAppUi * iSendUi;
	class CDb*	iTagDb;
	class CTagStorage* iTagStorage;
	class CBBPresence* iPresence;
	class CAknIconArray * iTagIcons;
	class CTimeOut*	iTimer;
	TInt		iTimerWait;

	TBool	iIsActivated;
	MAskForNames* iAskForNames;
};

#endif