#include "break.h"
#include "cm_oldprompt.h"
#include "cl_settings.h"
#include <fbs.h>


EXPORT_C TCMOldPrompt::TCMOldPrompt(CPostStorage &aStorage, CCMNetwork &aNetwork,
				    TInt64 aParentId) : iStorage(aStorage), iNetwork(aNetwork), iParentId(aParentId)
{
}

void TCMOldPrompt::Prompt(const TDesC& FileName, MUploadCallBack* CallBack)
{
	auto_ptr<CFbsBitmap> bm;
	auto_ptr<CCMPost> b(CCMPost::NewL(0));
	TFileOpStatus ret;
	TTime t; t=GetTime();

	b->iPostId() = CPostStorage::AddMeToMediaPoolId();
	b->iParentId() = iParentId;
	b->iMediaUrl() = FileName;

	TBuf<40> mime;
	GetMimeTypeL(FileName, mime);
	

	b->iContentType() = mime;
	b->iUnreadCounter() = 1;
	b->iTimeStamp() = t;

	TBuf<50> buf;
	if ( Settings().GetSettingL(SETTING_PUBLISH_AUTHOR, buf ) && buf.Length() != 0) {
		b->iSender.iName() = buf;
	}

	iStorage.AddLocalL(b.get(), bm);

	ret = CallBack->Back(false, false, b.get());
	

	CCMPost * anotherPost = iStorage.GetByPostIdL(0, b->iPostId());
	if (ret.err == KErrNone && ret.fn.Length()>0) {
		anotherPost->iMediaUrl() = ret.fn;
		anotherPost->iMediaFileName() = ret.fn;
		CC_TRAPD(ignore, iStorage.UpdatePostL(anotherPost));
	}
	iNetwork.FetchMedia(anotherPost);
	iStorage.Release(anotherPost, 0);
}