/* 
    Copyright (C) 2004  Mika Raento - Renaud Petit

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


    email: mraento@cs.helsinki.fi - petit@cs.helsinki.fi 
*/

#ifndef CONTEXTFLICKRAPPUI_H
#define CONTEXTFLICKRAPPUI_H

#include "appuibase.h"


class CContextFlickrAppUi : public CContextLogAppUiBase {
public: // // Constructors and destructor
	
	CContextFlickrAppUi(MApp_context& Context, class CSplashScreen *aSplash) : CContextLogAppUiBase(Context), 
		iSplash(aSplash) { }
        void ConstructL();
        ~CContextFlickrAppUi();
	static TInt InitializationSteps();
	virtual void StepDone();
private:
        // From MEikMenuObserver
        void DynInitMenuPaneL(TInt aResourceId,CEikMenuPane* aMenuPane);
        void HandleCommandL(TInt aCommand);
	void FlShowSettings();
	class CNotifyState		*iContextRunning;
	typedef void (MContextAppUi::*TFlCallBack)(void);
	virtual void RunOp(TCallBack op);
	void SendLogsL();

	static const TInt KNetworkSettings[];
	static const TInt KAdvancedSettings[];
	static const TInt KBasicSettings[];

	class CSendAppUi * iSendUi;
	class CSettingsView *iSettingsView1, *iSettingsView2, *iSettingsView3; // owned by the framework
	class CSplashScreen* iSplash;
};


#endif