#ifndef CONTEXT_PRESENCEMAINTAINER_H_INCLUDED
#define CONTEXT_PRESENCEMAINTAINER_H_INCLUDED 1

#include "app_context.h"
#include "i_logger.h"
#include "locationing.h"
#include "settings.h"

class MPresencePublisherListener {
public:
	virtual void NotifyNewPresence(const class CBBPresence* Data)=0;
};

class CBTDeviceList;

class MPresenceMaintainer : public Mlogger, public MContextBase, public MNaming {
protected:
	MPresenceMaintainer(MApp_context& aContext, CBTDeviceList* aBuddyList,
					  CBTDeviceList *aLaptopBTs, CBTDeviceList *aDesktopBTs, 
					  CBTDeviceList *aPDABTs, class MAskForNames* aCellNames);
	void ConstructL();

	virtual void GotSignificantChange(TBool frozenChanged) = 0;
	// Mlogger
	virtual void NewSensorEventL(const TTupleName& aName, const TDesC& aSubName, 
		const CBBSensorEvent& aData);
	virtual void DeletedL(const TTupleName& aName, const TDesC& aSubName);

	class CBBPresence*	iData;
	class CBBPresence*	iFrozen; // must be created/deleted by the derived class
	TTime			iUnfreezeTime;
	CBTDeviceList		*iBuddyList, *iLaptopBTs, *iDesktopBTs, *iPDABTs;
	class MAskForNames* iCellNames;
public:
	virtual ~MPresenceMaintainer();
	const class CBBPresence* Data() const;
	virtual void add_cellid_name(const TBBCellId& cellid, const TDesC& name);
};

class CPresenceMaintainer: public CBase, public MPresenceMaintainer {
public:
	static CPresenceMaintainer* NewL(MApp_context& aContext, CBTDeviceList* aBuddyList,
					  CBTDeviceList *aLaptopBTs, CBTDeviceList *aDesktopBTs, 
					  CBTDeviceList *aPDABTs, class MAskForNames* aCellNames);
protected:
	CPresenceMaintainer(MApp_context& aContext, CBTDeviceList* aBuddyList,
					  CBTDeviceList *aLaptopBTs, CBTDeviceList *aDesktopBTs, 
					  CBTDeviceList *aPDABTs, class MAskForNames* aCellNames);

};

#endif
